TRP2_DB_Auras = nil;
--French
function TRP2_LoadDBAuras_1()
	TRP2_DB_Auras = {
		["AUR00001"] = { -- Test 1
			["Description"] = "Un état vide, sans aucune données.",
			["Nom"] = "État",
			["bAjout"] = false,
		},
		-----------------------
		-- BORDEL : 00010 à 00100
		-----------------------
		["AUR00010"] = { -- Vêtement en feu
			["Type"] = 1,
			["Description"] = "Une partie des vêtements de ce personnage sont en flammes.",
			["Nom"] = "Vêtements en feu",
			["OnLifeTimeEffet"] = "texte$Vos vêtements ne sont plus en flammes.$1;",
			["Createur"] = "Telkostrasz",
			["OnUpdateCondi"] = "rand$<=$20;",
			["Icone"] = "INV_Fabric_Spellfire",
			["OnUpdateEffet"] = "aura$AUR00011$0$1$1;",
			["OnReceiveEffet"] = "parole$voit ses vêtements prendre feu !$2;texte${r}Vos vêtements prennent feu !$3;son$Sound\\\\Spells\\\\FireWardTarget.wav$2$12;",
		},
		["AUR00011"] = { -- Blessure : Brulure fraiche
			["Nom"] = "Brûlure fraîche",
			["Type"] = 1,
			["EtatCat"] = 7,
			["Description"] = "Ce personnage a récemment été brûlé. Cette brûlure n'a pas encore été traitée.",
			["Icone"] = "Spell_Fire_Incinerate",
			["Createur"] = "Telkostrasz",
			["OnDestroyEffet"] = "texte$Votre brûlure est guérie.$1;",
		},
		["AUR00012"] = { -- Plaie à l'oeil gauche
			["Type"] = 1,
			["Description"] = "Une coupure légère au niveau de l'oeil gauche.\nVisibilité réduite.",
			["Icone"] = "Ability_Rogue_BloodyEye",
			["EtatCat"] = 7,
			["Nom"] = "Plaie à l'oeil gauche",
			["Createur"] = "Telkostrasz",
		},
		["AUR00013"] = { -- Plaie à l'oeil droit
			["Type"] = 1,
			["Description"] = "Une coupure légère au niveau de l'oeil droit.\nVisibilité réduite.",
			["Icone"] = "Ability_Rogue_BloodyEye",
			["EtatCat"] = 7,
			["Nom"] = "Plaie à l'oeil droit",
			["Createur"] = "Telkostrasz",
		},
		
		["AUR00014"] = { -- Fumée du sèche-cheveux
			["EtatCat"] = 12,
			["Type"] = 1,
			["Description"] = "Cette personne est couverte d'une épaisse couche de poussières et de cendres.",
			["Date"] = "25/05/11, 00:26:07 par Telkostrasz",
			["Nom"] = "Poussières et cendres",
			["Createur"] = "Telkostrasz",
			["OnUpdateCondi"] = "isswimming$==$\"1\";",
			["Icone"] = "inv_misc_dust",
			["DureeDefaut"] = 20,
			["OnUpdateEffet"] = "aura$AUR00014$0$2$1;texte${me} est maintenant propre après son passage dans l'eau.$1;son$Sound\\\\Spells\\\\WaterElementalLow_Imapct_Base2.wav$1$0;",
		},
		-----------------------
		-- Humeur et emotions et comportements : 00501 à 00550
		-----------------------
		-- Comportement
		["AUR00501"] = { -- Apathique
			["Createur"] = "Telkosträsz",
			["Description"] = "Ce personnage est mou, totalement amorphe.",
			["Icone"] = "Spell_Shadow_MindSteal",
			["Nom"] = "Apathique",
			["EtatCat"] = 5,
		},
		["AUR00511"] = { -- Calme
			["Createur"] = "Telkosträsz",
			["Description"] = "Ce personnage est calme.",
			["Icone"] = "Ability_Mage_PotentSpirit",
			["Nom"] = "Calme",
			["EtatCat"] = 5,
		},
		["AUR00512"] = { -- Agité
			["Createur"] = "Telkosträsz",
			["Description"] = "Ce personnage est très agité. Il ne tient pas en place.",
			["Icone"] = "Achievement_BG_captureflag_EOS",
			["Nom"] = "Agité",
			["EtatCat"] = 5,
		},
		["AUR00509"] = { -- Dans la lune
			["Createur"] = "Ænys",
			["Description"] = "Ce personnage est dans la lune, perdu dans ses pensées.",
			["Icone"] = "Ability_Druid_Eclipse",
			["Nom"] = "Dans la lune",
			["EtatCat"] = 5,
		},
		["AUR00504"] = { -- Aux aguets
			["Description"] = "Ce personnage est attentif à tout ce qui se passe autour de lui ... Il peut être très réactif en cas de problème.",
			["Icone"] = "Ability_Druid_SupriseAttack",
			["Nom"] = "Aux aguets",
			["Createur"] = "Elindorië",
			["EtatCat"] = 5,
		},
		["AUR00513"] = { -- Observateur
			["Createur"] = "Kâsu",
			["Description"] = "Ce personnage observe tranquillement les gens autours de lui en faisant attention aux moindres détails.",
			["Icone"] = "ACHIEVEMENT_GUILDPERK_EVERYONES A HERO_RANK2",
			["Nom"] = "Observateur",
			["EtatCat"] = 5,
		},
		["AUR00514"] = { -- Timbré
			["Createur"] = "Anundæl",
			["Description"] = "Ce personnage a peut-être une case en moins, une pathologie particulière ou une mentalité hors des sentiers battus. Mieux vaut garder ses distances.",
			["Icone"] = "INV_Misc_Ticket_Tarot_Madness",
			["Nom"] = "Timbré",
			["EtatCat"] = 5,
		},
		["AUR00516"] = { -- Farceur
			["Createur"] = "Fimble",
			["Description"] = "Toujours prêt à rire de quelque chose ou quelqu'un, ou à tourner des paroles en ridicule.",
			["Icone"] = "Achievement_Character_Gnome_Male",
			["Nom"] = "Farceur",
			["EtatCat"] = 5,
		},
		["AUR00518"] = { -- Ivre
			["Createur"] = "Telkostrasz",
			["Description"] = "Ce personnage est complèment ivre !",
			["Icone"] = "INV_Drink_29_SunkissedWine",
			["Nom"] = "Ivre mort",
			["EtatCat"] = 5,
			["Type"] = 1,
		},
		-- Humeur
		["AUR00517"] = { -- Amoureux
			["Createur"] = "Märion",
			["Description"] = "Ce personnage est amoureux, et cela se voit !",
			["Icone"] = "Achievement_WorldEvent_Valentine",
			["Nom"] = "Amoureux",
			["EtatCat"] = 6,
		},
		["AUR00502"] = { -- Content
			["Createur"] = "Telkosträsz",
			["Description"] = "Ce personnage est heureux et de bonne humeur.",
			["Icone"] = "Spell_Shaman_GiftEarthmother",
			["Nom"] = "Content",
			["EtatCat"] = 6,
		},
		["AUR00505"] = { -- Colère
			["Createur"] = "Telkosträsz",
			["Description"] = "Ce personnage est en colère.",
			["Icone"] = "Spell_Misc_EmotionAngry",
			["Nom"] = "En colère",
			["EtatCat"] = 6,
		},
		["AUR00506"] = { -- Triste
			["Createur"] = "Telkosträsz",
			["Description"] = "Ce personnage est triste.",
			["Icone"] = "Spell_Misc_EmotionSad",
			["Nom"] = "Triste",
			["EtatCat"] = 6,
		},
		["AUR00508"] = { -- Impassible
			["Createur"] = "Telkosträsz",
			["Description"] = "Quelle que soit son humeur, ce personnage la cache derrière un visage fermé et inexpressif.",
			["Icone"] = "Ability_Rogue_Disguise",
			["Nom"] = "Impassible",
			["EtatCat"] = 6,
		},
		["AUR00510"] = { -- Affectueux
			["Createur"] = "Telkosträsz",
			["Description"] = "Ce personnage montre de affection à tout ce qui l'entoure.",
			["Icone"] = "INV_ValentinesCandy",
			["Nom"] = "Affectueux",
			["EtatCat"] = 6,
		},
		
		-- ACTION
		["AUR00515"] = { -- Fume le cigare
			["Createur"] = "Darnat",
			["Description"] = "Qui a dit que fumer nuisait à la santé ?",
			["Icone"] = "INV_Misc_Flute_01",
			["Nom"] = "Fume le cigare",
			["EtatCat"] = 13,
		},
		
		-- Odeur : 00551 à 00600
		["AUR00551"] = { -- Sang
			["Createur"] = "Telkostrasz",
			["Description"] = "Ce personnage est poursuivi par une odeur de sang séché.",
			["Icone"] = "Spell_Shadow_BloodBoil",
			["Nom"] = "Odeur de sang",
			["EtatCat"] = 4,
		},
		["AUR00552"] = { -- Tabac
			["Createur"] = "Telkostrasz",
			["Description"] = "Une vieille odeur de tabac froid émane de ce personnage.",
			["Icone"] = "INV_Misc_Dust_02",
			["Nom"] = "Odeur de tabac",
			["EtatCat"] = 4,
		},
		["AUR00553"] = { -- Fromage
			["Createur"] = "Telkostrasz",
			["Description"] = "Ce personnage sent le fromage fort !",
			["Icone"] = "INV_Misc_Food_03",
			["Nom"] = "Odeur de fromage",
			["EtatCat"] = 4,
		},
		["AUR00554"] = { -- Rose
			["Description"] = "Une odeur de rose émane de ce personnage.",
			["Icone"] = "INV_RoseBouquet01",
			["Nom"] = "Odeur de rose",
			["Createur"] = "Ulra",
			["EtatCat"] = 4,
		},
		["AUR00555"] = { -- Printemps
			["Createur"] = "Bérénisse",
			["Description"] = "Une fraiche odeur fleurie et légère émane de cette personne.",
			["Icone"] = "INV_Misc_TrailofFlowers",
			["Nom"] = "Odeur du printemps",
			["EtatCat"] = 4,
		},
		["AUR00556"] = { -- Foret
			["Description"] = "Une odeur de fleur pafumée, de forêt et d'une piquante et fraiche rosée se fait sentir sur ce personnage.",
			["Icone"] = "Ability_Druid_Flourish",
			["Nom"] = "Odeur de la forêt",
			["Createur"] = "Nandieb",
			["EtatCat"] = 4,
		},
		["AUR00557"] = { -- Cadavre
			["Description"] = "Ce personnage dégage une odeur de cadavre en putréfaction.",
			["Icone"] = "Spell_Shadow_DeathCoil",
			["Nom"] = "Odeur de cadavre",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 4,
		},
		["AUR00558"] = { -- Œuf pourri
			["Description"] = "Ce personnage dégage une atroce odeur d'œuf pourri.",
			["Icone"] = "Achievement_Halloween_RottenEgg_01",
			["Nom"] = "Odeur d'œuf pourri",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 4,
		},
		["AUR00559"] = { -- Viande fraiche
			["Description"] = "Une belle odeur de viande fraiche émane de ce personnage.",
			["Icone"] = "INV_Misc_Food_Meat_Raw_03",
			["Nom"] = "Odeur de viande fraiche",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 4,
		},
		["AUR00560"] = { -- Poisson
			["Description"] = "Ce personnage sent le poisson frais !",
			["Icone"] = "INV_Misc_Fish_17",
			["Nom"] = "Odeur de poisson frais",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 4,
		},
		["AUR00561"] = { -- Mer
			["Description"] = "Une fine odeur d'eau salée et de crustacé émane de cette personne.",
			["Icone"] = "INV_Misc_Fish_15",
			["Nom"] = "Odeur de la mer",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 4,
		},
		["AUR00562"] = { -- Animal
			["Description"] = "Ce personnage dégage une odeur d'animal.",
			["Icone"] = "Ability_Hunter_CatlikeReflexes",
			["Nom"] = "Odeur d'animal",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 4,
		},
		
		-- Maladie 00601 à 00700
		["AUR00601"] = { -- Rhume
			["Description"] = "Ce personnage montre les symptômes d'un gros rhume : nez qui coule, toux passagère et parfois des petites montées de fièvre.",
			["Icone"] = "INV_Elemental_Mote_Water01",
			["Nom"] = "Rhume",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 8,
			["Type"] = 1,
		},
		["AUR00602"] = { -- Asthme
			["Description"] = "Cette personne est très rapidemment essouflée. Elle souffre aussi de crises d'asthme passagères.",
			["Icone"] = "inv_misc_volatileair",
			["Nom"] = "Asthme",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 8,
			["Type"] = 1,
		},
		
		
		-- Malédictions 00701 à 00800
		["AUR00701"] = { -- Malédiction de douleur
			["Description"] = "Des illusions dévorent le corps de cette personne, mais la douleur est bien réelle...",
			["Icone"] = "Ability_Vanish",
			["Nom"] = "Malédiction de douleur",
			["Createur"] = "Knilthas",
			["EtatCat"] = 9,
			["Type"] = 1,
		},
		["AUR00702"] = { -- Malédiction de désespoir
			["Description"] = "Des voix internes rabaissent sans arrêt ce personnage.",
			["Icone"] = "Spell_Holy_PrayerofShadowProtection",
			["Nom"] = "Malédiction de désespoir",
			["Createur"] = "Knilthas",
			["EtatCat"] = 9,
			["Type"] = 1,
		},
		["AUR00703"] = { -- Malédiction de l'ombre
			["Description"] = "Tout sort de soin dirigé vers ce personnage le blesse.",
			["Icone"] = "Ability_Rogue_EnvelopingShadows",
			["Nom"] = "Malédiction de l'ombre",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 9,
			["Type"] = 1,
		},
		
		-- Magie 00801 à 00900
		["AUR00801"] = { -- Silence
			["Description"] = "Une magie empêche ce personnage d'incanter des sorts.",
			["Icone"] = "SPELL_HOLY_SILENCE",
			["Nom"] = "Silence",
			["Createur"] = "Knilthas",
			["EtatCat"] = 10,
			["Type"] = 1,
		},
		["AUR00802"] = { -- Miniature
			["Description"] = "Une magie a diminué la taille de ce personnage !",
			["Icone"] = "INV_Gizmo_Poltryiser_01",
			["Nom"] = "Miniaturisé",
			["Createur"] = "Knilthas",
			["EtatCat"] = 10,
			["Type"] = 1,
		},
		["AUR00803"] = { -- Lenteur
			["Description"] = "Des chaines magiques sont appliquées aux membres moteurs de ce personnage. Il est ralenti dans ses mouvements.",
			["Icone"] = "Spell_Nature_TimeStop",
			["Nom"] = "Lenteur",
			["Createur"] = "Knilthas",
			["EtatCat"] = 10,
			["Type"] = 1,
		},
		["AUR00804"] = { -- Illusion
			["Description"] = "Ce personnage cache quelque chose sous une toile illusoire, ceux qui y sont sensibles sentiront que quelque chose cloche.",
			["Icone"] = "INV_Inscription_TarotIllusion",
			["Nom"] = "Illusion",
			["Createur"] = "Céralynde",
			["EtatCat"] = 10,
			["Type"] = 2,
		},
		
		-- Apparence : 00901 à 01000
		["AUR00503"] = { -- Fatigue
			["Description"] = "Ce personnage est fatigué. Il n'a apparemment pas dormi depuis longtemps.",
			["Icone"] = "Spell_Nature_Sleep",
			["Nom"] = "Fatigue",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 11,
		},
		["AUR00901"] = { -- Sourire éclatant
			["Description"] = "Cette personne a visiblement une excellente hygiène buccale. Son sourire est éclatant !",
			["Icone"] = "Achievement_Halloween_Smiley_01",
			["Nom"] = "Sourire éclatant",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 11,
			["Type"] = 3,
		},
		["AUR00902"] = { -- Silhouette musclée
			["Description"] = "Ce personnage fait de la gonflette, et cela se voit !",
			["Icone"] = "Spell_Nature_Strength",
			["Nom"] = "Silhouette musclée",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 11,
			["Type"] = 3,
		},
		["AUR00903"] = { -- Soin de l'apparence
			["Description"] = "Ce personnage attache visiblement beaucoup d'importance à son apparence.",
			["Icone"] = "Achievement_BG_most_damage_killingblow_dieleast",
			["Nom"] = "Soin de l'apparence",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 11,
			["Type"] = 3,
		},
		["AUR00904"] = { -- Peinture de guerre
			["Description"] = "Ce personnage porte des peintures de guerre sur le visage.",
			["Icone"] = "ability_rogue_preparation",
			["Nom"] = "Peintures de guerre",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 11,
			["Type"] = 2,
		},
		["AUR00905"] = { -- Trempé
			["Description"] = "Ce personnage est trempé.",
			["Icone"] = "inv_misc_volatilewater",
			["Nom"] = "Trempé jusqu'aux os",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 11,
			["Type"] = 2,
		},
		["AUR00906"] = { -- Richesse
			["Createur"] = "Telkostrasz",
			["Description"] = "Vêtements de qualité, bourse bien remplie ... Tout indique que ce personnage n'a aucun soucis financier, bien au contraire !",
			["Icone"] = "ACHIEVEMENT_GUILDPERK_CASHFLOW_RANK2",
			["Nom"] = "Richesse",
			["EtatCat"] = 11,
		},
		["AUR00907"] = { -- Pauvreté
			["Createur"] = "Telkostrasz",
			["Description"] = "Vêtements sales et troués, estomac qui gronde ... Tout indique que ce personnage est sans le sou.",
			["Icone"] = "INV_Misc_Pelt_Bear_Ruin_05",
			["Nom"] = "Pauvreté",
			["EtatCat"] = 11,
		},
		["AUR00908"] = { -- Pupille dilatée
			["Description"] = "Ce personnage a les pupilles dilatées.",
			["Icone"] = "Ability_Hunter_BeastWithin",
			["Nom"] = "Mydriase",
			["Createur"] = "Damön",
			["EtatCat"] = 11,
			["Type"] = 1,
		},
		-- Aura 01001 à 01100
		["AUR01001"] = { -- Confiance
			["Description"] = "Cette personne dégage une aura inspirant la confiance.",
			["Icone"] = "Spell_Holy_AuraMastery",
			["Nom"] = "Confiance",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 14,
			["Type"] = 2,
		},
		["AUR01002"] = { -- Louche
			["Description"] = "Ce personne n'a pas l'air net. Il inspire la méfiance.",
			["Icone"] = "Ability_Rogue_WrongfullyAccused",
			["Nom"] = "Louche",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 14,
			["Type"] = 2,
		},
		
		-- Symptômes 01101 à 01200
		["AUR01101"] = { -- Paralysie
			["Description"] = "Cette personne est paralisée et est incapable de bouger. Ses muscles sont crispés et ne répondent plus.",
			["Icone"] = "Ability_Rogue_DeadenedNerves",
			["Nom"] = "Paralysie",
			["Createur"] = "Knilthas",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01102"] = { -- Engourdissement
			["Description"] = "Les membres de cette personne sont engourdis. Il a difficile à se mouvoir et son sens du toucher est affecté.",
			["Icone"] = "Spell_Frost_ManaRecharge",
			["Nom"] = "Engourdissements",
			["Createur"] = "Knilthas",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01103"] = { -- Affaiblissement
			["Description"] = "Ce personnage est affaiblit. Sa vivacité est diminuée, tout comme ses réflexes.",
			["Icone"] = "Spell_Shadow_ManaFeed",
			["Nom"] = "Affaiblissement",
			["Createur"] = "Knilthas",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01104"] = { -- Somnolence
			["Description"] = "La somnolence s'acharne sur ce personnage. Il a du mal à rester éveillé et concentré.",
			["Icone"] = "Spell_Nature_Polymorph",
			["Nom"] = "Somnolence",
			["Createur"] = "Knilthas",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01105"] = { -- Surdité
			["Description"] = "Ce personnage a perdu partiellement ses capacités auditives.",
			["Icone"] = "INV_Misc_Ear_Human_02",
			["Nom"] = "Surdité",
			["Createur"] = "Knilthas",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01106"] = { -- Cécité
			["Description"] = "Cette personne a partiellement (ou totalement) perdu la vue.",
			["Icone"] = "Spell_Arcane_Blink",
			["Nom"] = "Cécité",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01107"] = { -- Aphasie
			["Description"] = "Ce personnage a perdu l'usage de la parole.",
			["Icone"] = "Ability_Priest_Silence",
			["Nom"] = "Aphasie",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01108"] = { -- Nausée
			["Description"] = "Cette personne est parfois prise de vomissements.",
			["Icone"] = "Spell_Shadow_SoulLeech",
			["Nom"] = "Nausée",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01109"] = { -- Fièvre
			["Description"] = "Cette personne est fiévreuse.",
			["Icone"] = "Spell_Shadow_MindRot",
			["Nom"] = "Fièvre",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01110"] = { -- Toux faible
			["Description"] = "Cette personne tousse de temps en temps.",
			["Icone"] = "Ability_Rogue_MasterOfSubtlety",
			["Nom"] = "Faible toux",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR00507"] = { -- Migraine
			["Type"] = 1,
			["Description"] = "Ce personnage souffre d'une migraine abominable.",
			["Icone"] = "Spell_Arcane_MindMastery",
			["Nom"] = "Migraine",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 16,
		},
		["AUR00015"] = { -- Boiter
			["Type"] = 1,
			["Description"] = "Ce personnage boite et risque parfois de trébucher lors de ses déplacements.",
			["Icone"] = "Ability_Rogue_Trip",
			["Nom"] = "Boiteux",
			["Createur"] = "Telkostrasz",
			["OnUpdateCondi"] = "rand$<=$2;speed$>$0;ismount$~=$\"1\"",
			["OnUpdateEffet"] = "parole${randtext:trébuche+trébuche mais retrouve aussitôt son équilibre+trébuche et perd son équilibre+trébuche, perd son équilibre et s'étale lamentablement par terre}.$2;",
			["EtatCat"] = 16,
		},
		["AUR01111"] = { -- Amnésie partielle
			["Description"] = "Cette personne a actuellement perdu une partie de ses souvenirs.",
			["Icone"] = "Ability_Druid_Dreamstate",
			["Nom"] = "Amnésie passagère",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01112"] = { -- Amnésie totale
			["Description"] = "Cette personne a perdu toute sa mémoire. Elle ne sait même plus qui elle est.",
			["Icone"] = "Ability_Druid_Dreamstate",
			["Nom"] = "Amnésie totale",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		
		-----------------------
		-- Quetes : 00101 à 00500
		-----------------------
		-- Quête : Traitresse ! Horde --
		["AUR00101"] = { -- Distraction de Gryshka
			["Description"] = "Ce personnage a distrait Gryshka. Il peut en profiter pour lui dérober un objet !",
			["OnLifeTimeCondi"] = "queststep(QUE00003)$==$\"006\";",
			["Nom"] = "Distraction : Gryshka",
			["EtatCat"] = 3,
			["bAjout"] = false,
			["OnLifeTimeEffet"] = "quest$QUE00003$005$1;",
			["Createur"] = "Telkostrasz",
			["Icone"] = "Achievement_Character_Orc_Female",
			["OnReceiveEffet"] = "texte$Gryshka est distraite  !\nProfitez en pour la fouiller !$3;",
		},
		-- Quête : Traitresse ! Alliance --
		["AUR00102"] = { -- Distraction de Erika
			["Description"] = "Ce personnage a distrait Erika. Il peut en profiter pour lui dérober un objet !",
			["OnLifeTimeCondi"] = "queststep(QUE00002)$==$\"006\";",
			["Nom"] = "Distraction : Erika",
			["bAjout"] = false,
			["EtatCat"] = 3,
			["OnLifeTimeEffet"] = "quest$QUE00002$005$1;",
			["Createur"] = "Telkostrasz",
			["Icone"] = "Achievement_Character_Human_Female",
			["OnReceiveEffet"] = "texte$Erika est distraite  !\nProfitez en pour la fouiller !$3;",
		},
	}
end
--English
function TRP2_LoadDBAuras_2()
	TRP2_DB_Auras = {
		["AUR00001"] = { -- Test 1
			["Description"] = "A blank state, with no data.",
			["Nom"] = "State",
			["bAjout"] = false,
		},
		-----------------------
		-- BORDEL : 00010 à 00100
		-----------------------
		["AUR00012"] = { -- Plaie à l'oeil gauche
			["Type"] = 1,
			["Description"] = "A shallow cut near the left eye.\nBarely visible.",
			["Icone"] = "Ability_Rogue_BloodyEye",
			["EtatCat"] = 7,
			["Nom"] = "Wounded left eye",
			["Createur"] = "Telkostrasz",
		},
		["AUR00013"] = { -- Plaie à l'oeil droit
			["Type"] = 1,
			["Description"] = "A shallow cut near the right eye.\nBarely visible.",
			["Icone"] = "Ability_Rogue_BloodyEye",
			["EtatCat"] = 7,
			["Nom"] = "Wounded right eye",
			["Createur"] = "Telkostrasz",
		},
		
		["AUR00014"] = { -- Fumée du sèche-cheveux
			["EtatCat"] = 12,
			["Type"] = 1,
			["Description"] = "This character is covered with a thick coat of dusts and ashes.",
			["Date"] = "25/05/11, 00:26:07 par Telkostrasz",
			["Nom"] = "Dusts and ashes",
			["Createur"] = "Telkostrasz",
			["OnUpdateCondi"] = "isswimming$==$\"1\";",
			["Icone"] = "inv_misc_dust",
			["DureeDefaut"] = 20,
			["OnUpdateEffet"] = "aura$AUR00014$0$2$1;texte${me} is now clean after swimming in the water.$1;son$Sound\\\\Spells\\\\WaterElementalLow_Imapct_Base2.wav$1$0;",
		},
		-----------------------
		-- Humeur et emotions et comportements : 00501 à 00550
		-----------------------
		-- Comportement
		["AUR00501"] = { -- Apathique
			["Createur"] = "Telkosträsz",
			["Description"] = "This character is dispassionate and nonchalant.",
			["Icone"] = "Spell_Shadow_MindSteal",
			["Nom"] = "Apathetic",
			["EtatCat"] = 5,
		},
		["AUR00511"] = { -- Calme
			["Createur"] = "Telkosträsz",
			["Description"] = "This character is quiet.",
			["Icone"] = "Ability_Mage_PotentSpirit",
			["Nom"] = "Quiet",
			["EtatCat"] = 5,
		},
		["AUR00512"] = { -- Agité
			["Createur"] = "Telkosträsz",
			["Description"] = "This character is flustered and restless.",
			["Icone"] = "Achievement_BG_captureflag_EOS",
			["Nom"] = "Restless",
			["EtatCat"] = 5,
		},
		["AUR00509"] = { -- Dans la lune
			["Createur"] = "Ænys",
			["Description"] = "This character is distracted, day-dreaming.",
			["Icone"] = "Ability_Druid_Eclipse",
			["Nom"] = "Woolgathering",
			["EtatCat"] = 5,
		},
		["AUR00504"] = { -- Aux aguets
			["Description"] = "This character is paying a lot of attention to what's happening around them... They may be quick to react in case there's a problem.",
			["Icone"] = "Ability_Druid_SupriseAttack",
			["Nom"] = "On the look-out",
			["Createur"] = "Elindorië",
			["EtatCat"] = 5,
		},
		["AUR00513"] = { -- Observateur
			["Createur"] = "Kâsu",
			["Description"] = "This character is watching the people around them, making mental notes of every details.",
			["Icone"] = "ACHIEVEMENT_GUILDPERK_EVERYONES A HERO_RANK2",
			["Nom"] = "Observant",
			["EtatCat"] = 5,
		},
		["AUR00514"] = { -- Timbré
			["Createur"] = "Anundæl",
			["Description"] = "This character looks sort of crazy. It's either a medical condition or a peculiar frame of mind. In any case, it'd be wiser to stay away.",
			["Icone"] = "INV_Misc_Ticket_Tarot_Madness",
			["Nom"] = "Nuts",
			["EtatCat"] = 5,
		},
		["AUR00516"] = { -- Farceur
			["Createur"] = "Fimble",
			["Description"] = "Always up for a good laugh and ready to make fun of what people say.",
			["Icone"] = "Achievement_Character_Gnome_Male",
			["Nom"] = "Joker",
			["EtatCat"] = 5,
		},
		["AUR00518"] = { -- Ivre
			["Createur"] = "Telkostrasz",
			["Description"] = "This character is utterly drunk!",
			["Icone"] = "INV_Drink_29_SunkissedWine",
			["Nom"] = "Rat-arsed drunk",
			["EtatCat"] = 5,
			["Type"] = 1,
		},
		-- Humeur
		["AUR00517"] = { -- Amoureux
			["Createur"] = "Märion",
			["Description"] = "This character's in love and it shows!",
			["Icone"] = "Achievement_WorldEvent_Valentine",
			["Nom"] = "In love",
			["EtatCat"] = 6,
		},
		["AUR00502"] = { -- Content
			["Createur"] = "Telkosträsz",
			["Description"] = "This character's happy and in a good mood.",
			["Icone"] = "Spell_Shaman_GiftEarthmother",
			["Nom"] = "Happy",
			["EtatCat"] = 6,
		},
		["AUR00505"] = { -- Colère
			["Createur"] = "Telkosträsz",
			["Description"] = "This character is angry.",
			["Icone"] = "Spell_Misc_EmotionAngry",
			["Nom"] = "Angry",
			["EtatCat"] = 6,
		},
		["AUR00506"] = { -- Triste
			["Createur"] = "Telkosträsz",
			["Description"] = "This character is sad.",
			["Icone"] = "Spell_Misc_EmotionSad",
			["Nom"] = "Sad",
			["EtatCat"] = 6,
		},
		["AUR00508"] = { -- Impassible
			["Createur"] = "Telkosträsz",
			["Description"] = "Whatever this character's mood is or what they're thinking, it doesn't show on their face.",
			["Icone"] = "Ability_Rogue_Disguise",
			["Nom"] = "Poker Face",
			["EtatCat"] = 6,
		},
		["AUR00510"] = { -- Affectueux
			["Createur"] = "Telkosträsz",
			["Description"] = "This character's affectionate with everyone around them.",
			["Icone"] = "INV_ValentinesCandy",
			["Nom"] = "Affectionate",
			["EtatCat"] = 6,
		},
		
		-- ACTION
		["AUR00515"] = { -- Fume le cigare
			["Createur"] = "Darnat",
			["Description"] = "Who said smoking was unhealthy?",
			["Icone"] = "INV_Misc_Flute_01",
			["Nom"] = "Cigar-smoking",
			["EtatCat"] = 13,
		},
		
		-- Odeur : 00551 à 00600
		["AUR00551"] = { -- Sang
			["Createur"] = "Telkostrasz",
			["Description"] = "This character smells of dry blood.",
			["Icone"] = "Spell_Shadow_BloodBoil",
			["Nom"] = "Smell of blood",
			["EtatCat"] = 4,
		},
		["AUR00552"] = { -- Tabac
			["Createur"] = "Telkostrasz",
			["Description"] = "This character smells of tobacco.",
			["Icone"] = "INV_Misc_Dust_02",
			["Nom"] = "Smell of tobacco",
			["EtatCat"] = 4,
		},
		["AUR00553"] = { -- Fromage
			["Createur"] = "Telkostrasz",
			["Description"] = "This character smells of cheese!",
			["Icone"] = "INV_Misc_Food_03",
			["Nom"] = "Smell of cheese",
			["EtatCat"] = 4,
		},
		["AUR00554"] = { -- Rose
			["Description"] = "This character smells of roses.",
			["Icone"] = "INV_RoseBouquet01",
			["Nom"] = "Smell of roses",
			["Createur"] = "Ulra",
			["EtatCat"] = 4,
		},
		["AUR00555"] = { -- Printemps
			["Createur"] = "Bérénisse",
			["Description"] = "This character smells of flower and spring.",
			["Icone"] = "INV_Misc_TrailofFlowers",
			["Nom"] = "Smell of spring",
			["EtatCat"] = 4,
		},
		["AUR00556"] = { -- Foret
			["Description"] = "This character smells of fragrant flowers, spicey morning dew and forest.",
			["Icone"] = "Ability_Druid_Flourish",
			["Nom"] = "Smell of the forest",
			["Createur"] = "Nandieb",
			["EtatCat"] = 4,
		},
		["AUR00557"] = { -- Cadavre
			["Description"] = "This character smells like a rotting corpse.",
			["Icone"] = "Spell_Shadow_DeathCoil",
			["Nom"] = "Smell of death",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 4,
		},
		["AUR00558"] = { -- Œuf pourri
			["Description"] = "This character smells of rotten eggs.",
			["Icone"] = "Achievement_Halloween_RottenEgg_01",
			["Nom"] = "Smell of rotten eggs",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 4,
		},
		["AUR00559"] = { -- Viande fraiche
			["Description"] = "This character smells of deliciously-fresh meat.",
			["Icone"] = "INV_Misc_Food_Meat_Raw_03",
			["Nom"] = "Smell of fresh meat",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 4,
		},
		["AUR00560"] = { -- Poisson
			["Description"] = "This character smells of fresh fish!",
			["Icone"] = "INV_Misc_Fish_17",
			["Nom"] = "Smell of fresh fish",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 4,
		},
		["AUR00561"] = { -- Mer
			["Description"] = "This person smells of sea water and shellfish.",
			["Icone"] = "INV_Misc_Fish_15",
			["Nom"] = "Smell of the ocean",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 4,
		},
		["AUR00562"] = { -- Animal
			["Description"] = "This character smells of beasts.",
			["Icone"] = "Ability_Hunter_CatlikeReflexes",
			["Nom"] = "Smell of beasts",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 4,
		},
		
		-- Maladie 00601 à 00700
		["AUR00601"] = { -- Rhume
			["Description"] = "This character obviously has a cold: runny nose, coughing and a slight fever.",
			["Icone"] = "INV_Elemental_Mote_Water01",
			["Nom"] = "Cold",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 8,
			["Type"] = 1,
		},
		["AUR00602"] = { -- Asthme
			["Description"] = "This person's easily out-of-breath. They also have asthma fits.",
			["Icone"] = "inv_misc_volatileair",
			["Nom"] = "Asthma",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 8,
			["Type"] = 1,
		},
		
		
		-- Malédictions 00701 à 00800
		["AUR00701"] = { -- Malédiction de douleur
			["Description"] = "Illusions are eating away at this person' body, but the pain itself is real...",
			["Icone"] = "Ability_Vanish",
			["Nom"] = "Curse of pain",
			["Createur"] = "Knilthas",
			["EtatCat"] = 9,
			["Type"] = 1,
		},
		["AUR00702"] = { -- Malédiction de désespoir
			["Description"] = "Inner voices are always belittling this character.",
			["Icone"] = "Spell_Holy_PrayerofShadowProtection",
			["Nom"] = "Curse of despair",
			["Createur"] = "Knilthas",
			["EtatCat"] = 9,
			["Type"] = 1,
		},
		["AUR00703"] = { -- Malédiction de l'ombre
			["Description"] = "Healing spells harm this character instead of curing them.",
			["Icone"] = "Ability_Rogue_EnvelopingShadows",
			["Nom"] = "Curse of darkness",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 9,
			["Type"] = 1,
		},
		
		-- Magie 00801 à 00900
		["AUR00801"] = { -- Silence
			["Description"] = "A spell is preventing this character from incanting.",
			["Icone"] = "SPELL_HOLY_SILENCE",
			["Nom"] = "Silence",
			["Createur"] = "Knilthas",
			["EtatCat"] = 10,
			["Type"] = 1,
		},
		["AUR00802"] = { -- Miniature
			["Description"] = "A spell has made this character smaller!",
			["Icone"] = "INV_Gizmo_Poltryiser_01",
			["Nom"] = "Miniaturized",
			["Createur"] = "Knilthas",
			["EtatCat"] = 10,
			["Type"] = 1,
		},
		["AUR00803"] = { -- Lenteur
			["Description"] = "Magical chains restrain this character's limbs and hinder their movements.",
			["Icone"] = "Spell_Nature_TimeStop",
			["Nom"] = "Slowness",
			["Createur"] = "Knilthas",
			["EtatCat"] = 10,
			["Type"] = 1,
		},
		
		-- Apparence : 00901 à 01000
		["AUR00503"] = { -- Fatigue
			["Description"] = "This character's tired and hasn't slept in a while.",
			["Icone"] = "Spell_Nature_Sleep",
			["Nom"] = "Tiredness",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 11,
		},
		["AUR00901"] = { -- Sourire éclatant
			["Description"] = "This character has perfect dental hygiene. What a shining smile!",
			["Icone"] = "Achievement_Halloween_Smiley_01",
			["Nom"] = "Shining smile",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 11,
			["Type"] = 3,
		},
		["AUR00902"] = { -- Silhouette musclée
			["Description"] = "This character has been working out and it shows!",
			["Icone"] = "Spell_Nature_Strength",
			["Nom"] = "Bulging muscles",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 11,
			["Type"] = 3,
		},
		["AUR00903"] = { -- Soin de l'apparence
			["Description"] = "This character's neatly groomed and pays a lot of attention to their outward appearence.",
			["Icone"] = "Achievement_BG_most_damage_killingblow_dieleast",
			["Nom"] = "Neatly groomed",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 11,
			["Type"] = 3,
		},
		["AUR00904"] = { -- Peinture de guerre
			["Description"] = "This character wears war paints on their face.",
			["Icone"] = "ability_rogue_preparation",
			["Nom"] = "War paints",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 11,
			["Type"] = 2,
		},
		["AUR00905"] = { -- Trempé
			["Description"] = "This character is soaked.",
			["Icone"] = "inv_misc_volatilewater",
			["Nom"] = "Soaked",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 11,
			["Type"] = 2,
		},
		["AUR00906"] = { -- Richesse
			["Createur"] = "Telkostrasz",
			["Description"] = "Pricey clothes, a pouch filled with coins... This character doesn't have to worry about money. Quite the contrary!",
			["Icone"] = "ACHIEVEMENT_GUILDPERK_CASHFLOW_RANK2",
			["Nom"] = "Wealth",
			["EtatCat"] = 11,
		},
		["AUR00907"] = { -- Pauvreté
			["Createur"] = "Telkostrasz",
			["Description"] = "Worn-out clothes with holes in them, growling stomach... This character's without a dime.",
			["Icone"] = "INV_Misc_Pelt_Bear_Ruin_05",
			["Nom"] = "Poverty",
			["EtatCat"] = 11,
		},
		["AUR00908"] = { -- Pupille dilatée
			["Description"] = "This character's pupils are dilated.",
			["Icone"] = "Ability_Hunter_BeastWithin",
			["Nom"] = "Mydriasis",
			["Createur"] = "Damön",
			["EtatCat"] = 11,
			["Type"] = 1,
		},
		-- Aura 01001 à 01100
		["AUR01001"] = { -- Confiance
			["Description"] = "This character's got an aura of trustworthiness.",
			["Icone"] = "Spell_Holy_AuraMastery",
			["Nom"] = "Trustworthy",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 14,
			["Type"] = 2,
		},
		["AUR01002"] = { -- Louche
			["Description"] = "This character looks shady and doesn't inspire trust.",
			["Icone"] = "Ability_Rogue_WrongfullyAccused",
			["Nom"] = "Shady",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 14,
			["Type"] = 2,
		},
		
		-- Symptômes 01101 à 01200
		["AUR01101"] = { -- Paralysie
			["Description"] = "This character's paralyzed.",
			["Icone"] = "Ability_Rogue_DeadenedNerves",
			["Nom"] = "Paralyzed",
			["Createur"] = "Knilthas",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01102"] = { -- Engourdissement
			["Description"] = "The person's limbs are numb, making it hard to move and feel with touch.",
			["Icone"] = "Spell_Frost_ManaRecharge",
			["Nom"] = "Numbness",
			["Createur"] = "Knilthas",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01103"] = { -- Affaiblissement
			["Description"] = "This character is weakened. Their reflexes and energy levels are diminished.",
			["Icone"] = "Spell_Shadow_ManaFeed",
			["Nom"] = "Weakening",
			["Createur"] = "Knilthas",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01104"] = { -- Somnolence
			["Description"] = "Sleepiness is weighing on this character. They're having a hard time staying awake and focused.",
			["Icone"] = "Spell_Nature_Polymorph",
			["Nom"] = "Sleepiness",
			["Createur"] = "Knilthas",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01105"] = { -- Surdité
			["Description"] = "This character can't hear a thing.",
			["Icone"] = "INV_Misc_Ear_Human_02",
			["Nom"] = "Deaf",
			["Createur"] = "Knilthas",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01106"] = { -- Cécité
			["Description"] = "This character can't see a thing.",
			["Icone"] = "Spell_Arcane_Blink",
			["Nom"] = "Blindness",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01107"] = { -- Aphasie
			["Description"] = "This character's mute.",
			["Icone"] = "Ability_Priest_Silence",
			["Nom"] = "Muteness",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01108"] = { -- Nausée
			["Description"] = "This character's prone to vomit.",
			["Icone"] = "Spell_Shadow_SoulLeech",
			["Nom"] = "Nauseous",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01109"] = { -- Fièvre
			["Description"] = "This character has a fever.",
			["Icone"] = "Spell_Shadow_MindRot",
			["Nom"] = "Fever",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01110"] = { -- Toux faible
			["Description"] = "This character's coughing now and then.",
			["Icone"] = "Ability_Rogue_MasterOfSubtlety",
			["Nom"] = "Coughing",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01111"] = { -- Amnésie partielle
			["Description"] = "This character lost parts of his memories.",
			["Icone"] = "Ability_Druid_Dreamstate",
			["Nom"] = "Partial amnesia",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01112"] = { -- Amnésie totale
			["Description"] = "This character totally lose his memory. He don't even known who he is anymore.",
			["Icone"] = "Ability_Druid_Dreamstate",
			["Nom"] = "Complete amnesia",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		
		-----------------------
		-- Quetes : 00101 à 00500
		-----------------------
		-- Quête : Traitresse ! Horde --
		["AUR00101"] = { -- Distraction de Gryshka
			["Description"] = "This character has distracted Gryshka's attention. They can use the diversion to steal an item from her!",
			["OnLifeTimeCondi"] = "queststep(QUE00003)$==$\"006\";",
			["Nom"] = "Distraction: Gryshka",
			["EtatCat"] = 3,
			["bAjout"] = false,
			["OnLifeTimeEffet"] = "quest$QUE00003$005$1;",
			["Createur"] = "Telkostrasz",
			["Icone"] = "Achievement_Character_Orc_Female",
			["OnReceiveEffet"] = "texte$Gryshka's distracted!\nTake advantage of this to search her!$3;",
		},
		-- Quête : Traitresse ! Alliance --
		["AUR00102"] = { -- Distraction de Erika
			["Description"] = "This character has distracted Erika's attention. They can use the diversion to steal an item from her!",
			["OnLifeTimeCondi"] = "queststep(QUE00002)$==$\"006\";",
			["Nom"] = "Distraction: Erika",
			["bAjout"] = false,
			["EtatCat"] = 3,
			["OnLifeTimeEffet"] = "quest$QUE00002$005$1;",
			["Createur"] = "Telkostrasz",
			["Icone"] = "Achievement_Character_Human_Female",
			["OnReceiveEffet"] = "texte$Erika's distracted!\nTake advantage of this to search her!$3;",
		},
	}
end
--Spanish
function TRP2_LoadDBAuras_3()
	TRP2_DB_Auras = {
		["AUR00001"] = { -- Test 1
			["Description"] = "Un estado en blanco, sin datos.",
			["Nom"] = "Estado",
			["bAjout"] = false,
		},
		-----------------------
		-- BORDEL : 00010 à 00100
		-----------------------
		["AUR00012"] = { -- Plaie à l'oeil gauche
			["Type"] = 1,
			["Description"] = "Un corte superficial cerca del ojo izquierdo. Apenas visible.",
			["Icone"] = "Ability_Rogue_BloodyEye",
			["EtatCat"] = 7,
			["Nom"] = "Cicatriz en el ojo izquierdo",
			["Createur"] = "Telkostrasz",
		},
		["AUR00013"] = { -- Plaie à l'oeil droit
			["Type"] = 1,
			["Description"] = "Un corte superficial cerca del ojo derecho. Apenas visible.",
			["Icone"] = "Ability_Rogue_BloodyEye",
			["EtatCat"] = 7,
			["Nom"] = "Cicatriz en el ojo derecho",
			["Createur"] = "Telkostrasz",
		},
		["AUR00014"] = { -- Fumée du sèche-cheveux
			["EtatCat"] = 12,
			["Type"] = 1,
			["Description"] = "Este jugador está cubierto de una capa de polvo y cenizas.",
			["Date"] = "25/05/11, 00:26:07 par Telkostrasz",
			["Nom"] = "Polvo y cenizas",
			["Createur"] = "Telkostrasz",
			["OnUpdateCondi"] = "isswimming$==$\"1\";",
			["Icone"] = "inv_misc_dust",
			["DureeDefaut"] = 20,
			["OnUpdateEffet"] = "aura$AUR00014$0$2$1;texte${me} se ha limpiado tras nadar en el agua.$1;son$Sound\\\\Spells\\\\WaterElementalLow_Imapct_Base2.wav$1$0;",
		},
		-----------------------
		-- Humeur et emotions et comportements : 00501 à 00550
		-----------------------
		-- Comportement
		["AUR00501"] = { -- Apathique
			["Createur"] = "Telkostrasz",
			["Description"] = "Este personaje es desapasionado e indiferente.",
			["Icone"] = "Spell_Shadow_MindSteal",
			["Nom"] = "Apático",
			["EtatCat"] = 5,
		},
		["AUR00511"] = { -- Calme
			["Createur"] = "Telkostrasz",
			["Description"] = "Este personaje está tranquilo.",
			["Icone"] = "Ability_Mage_PotentSpirit",
			["Nom"] = "Tranquilo",
			["EtatCat"] = 5,
		},
		["AUR00512"] = { -- Agité
			["Createur"] = "Telkosträsz",
			["Description"] = "Este personaje está nervioso e inquieto.",
			["Icone"] = "Achievement_BG_captureflag_EOS",
			["Nom"] = "Inquieto",
			["EtatCat"] = 5,
		},
		["AUR00509"] = { -- Dans la lune
			["Createur"] = "Ænys",
			["Description"] = "Este personaje está distraido, soñando despierto.",
			["Icone"] = "Ability_Druid_Eclipse",
			["Nom"] = "Soñador",
			["EtatCat"] = 5,
		},
		["AUR00504"] = { -- Aux aguets
			["Description"] = "Este personaje está prestando mucha atención a lo que sucede a su alrededor... Podría reaccionar rápidamente en caso de que hubiera algún problema.",
			["Icone"] = "Ability_Druid_SupriseAttack",
			["Nom"] = "Alerta",
			["Createur"] = "Elindorië",
			["EtatCat"] = 5,
		},
		["AUR00513"] = { -- Observateur
			["Createur"] = "Kâsu",
			["Description"] = "Este personaje está observando a la gente a su alrededor, tomando nota mental de todos los detalles.",
			["Icone"] = "ACHIEVEMENT_GUILDPERK_EVERYONES A HERO_RANK2",
			["Nom"] = "Observador",
			["EtatCat"] = 5,
		},
		["AUR00514"] = { -- Timbré
			["Createur"] = "Anundæl",
			["Description"] = "Este personaje padece algún tipo de locura. Sería prudente mantenerse alejado.",
			["Icone"] = "INV_Misc_Ticket_Tarot_Madness",
			["Nom"] = "Chalado",
			["EtatCat"] = 5,
		},
		["AUR00516"] = { -- Farceur
			["Createur"] = "Fimble",
			["Description"] = "Siempre dispuesto a reírse de algo o alguien, o burlarse de lo que dice la gente.",
			["Icone"] = "Achievement_Character_Gnome_Male",
			["Nom"] = "Burlón",
			["EtatCat"] = 5,
		},
		["AUR00518"] = { -- Ivre
			["Createur"] = "Telkostrasz",
			["Description"] = "¡Este personaje está completamente borracho!",
			["Icone"] = "INV_Drink_29_SunkissedWine",
			["Nom"] = "Borracho",
			["EtatCat"] = 5,
			["Type"] = 1,
		},
		-- Humeur
		["AUR00517"] = { -- Amoureux
			["Createur"] = "Märion",
			["Description"] = "¡Este personaje está enamorado, y eso se nota!",
			["Icone"] = "Achievement_WorldEvent_Valentine",
			["Nom"] = "Enamorado",
			["EtatCat"] = 6,
		},
		["AUR00502"] = { -- Content
			["Createur"] = "Telkostrasz",
			["Description"] = "Este personaje está alegre y de buen humor.",
			["Icone"] = "Spell_Shaman_GiftEarthmother",
			["Nom"] = "Feliz",
			["EtatCat"] = 6,
		},
		["AUR00505"] = { -- Colère
			["Createur"] = "Telkostrasz",
			["Description"] = "Este personaje está enfadado.",
			["Icone"] = "Spell_Misc_EmotionAngry",
			["Nom"] = "Enfadado",
			["EtatCat"] = 6,
		},
		["AUR00506"] = { -- Triste
			["Createur"] = "Telkostrasz",
			["Description"] = "Este personaje está triste.",
			["Icone"] = "Spell_Misc_EmotionSad",
			["Nom"] = "Triste",
			["EtatCat"] = 6,
		},
		["AUR00508"] = { -- Impassible
			["Createur"] = "Telkostrasz",
			["Description"] = "Cualquiera que sea su estado de ánimo, el rostro de este personaje permanece inexpresivo.",
			["Icone"] = "Ability_Rogue_Disguise",
			["Nom"] = "Impasible",
			["EtatCat"] = 6,
		},
		["AUR00510"] = { -- Affectueux
			["Createur"] = "Telkostrasz",
			["Description"] = "Este personaje es afectuoso con todo el mundo.",
			["Icone"] = "INV_ValentinesCandy",
			["Nom"] = "Afectuoso",
			["EtatCat"] = 6,
		},
		
		-- ACTION
		["AUR00515"] = { -- Fume le cigare
			["Createur"] = "Darnat",
			["Description"] = "¿Quién dijo que fumar era poco saludable?",
			["Icone"] = "INV_Misc_Flute_01",
			["Nom"] = "Fumando",
			["EtatCat"] = 13,
		},
		
		-- Odeur : 00551 à 00600
		["AUR00551"] = { -- Sang
			["Createur"] = "Telkostrasz",
			["Description"] = "Este personaje huele a sangre seca.",
			["Icone"] = "Spell_Shadow_BloodBoil",
			["Nom"] = "Olor a sangre",
			["EtatCat"] = 4,
		},
		["AUR00552"] = { -- Tabac
			["Createur"] = "Telkostrasz",
			["Description"] = "Este personaje huele a tabaco.",
			["Icone"] = "INV_Misc_Dust_02",
			["Nom"] = "Olor a tabaco",
			["EtatCat"] = 4,
		},
		["AUR00553"] = { -- Fromage
			["Createur"] = "Telkostrasz",
			["Description"] = "¡Este personaje huele a queso!",
			["Icone"] = "INV_Misc_Food_03",
			["Nom"] = "Olor a queso",
			["EtatCat"] = 4,
		},
		["AUR00554"] = { -- Rose
			["Description"] = "Este personaje huele a rosas.",
			["Icone"] = "INV_RoseBouquet01",
			["Nom"] = "Olor a rosas",
			["Createur"] = "Ulra",
			["EtatCat"] = 4,
		},
		["AUR00555"] = { -- Printemps
			["Createur"] = "Bérénisse",
			["Description"] = "Este personaje huele a flores y primavera.",
			["Icone"] = "INV_Misc_TrailofFlowers",
			["Nom"] = "Olor a primavera",
			["EtatCat"] = 4,
		},
		["AUR00556"] = { -- Foret
			["Description"] = "Este personaje huele a flores fragantes, bosque y rocío de la mañana.",
			["Icone"] = "Ability_Druid_Flourish",
			["Nom"] = "Olor a bosque",
			["Createur"] = "Nandieb",
			["EtatCat"] = 4,
		},
		["AUR00557"] = { -- Cadavre
			["Description"] = "Este personaje huele a cadáver putrefacto.",
			["Icone"] = "Spell_Shadow_DeathCoil",
			["Nom"] = "Olor a muerto",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 4,
		},
		["AUR00558"] = { -- Œuf pourri
			["Description"] = "Este personaje huele a huevos podridos.",
			["Icone"] = "Achievement_Halloween_RottenEgg_01",
			["Nom"] = "Olor a huevos podridos",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 4,
		},
		["AUR00559"] = { -- Viande fraiche
			["Description"] = "Este personaje huele a deliciosa carne fresca.",
			["Icone"] = "INV_Misc_Food_Meat_Raw_03",
			["Nom"] = "Olor a carne fresca",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 4,
		},
		["AUR00560"] = { -- Poisson
			["Description"] = "¡Este personaje huele a pescado fresco!",
			["Icone"] = "INV_Misc_Fish_17",
			["Nom"] = "Olor a pescado fresco",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 4,
		},
		["AUR00561"] = { -- Mer
			["Description"] = "Este personaje huele a mar y marisco.",
			["Icone"] = "INV_Misc_Fish_15",
			["Nom"] = "Olor a mar",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 4,
		},
		["AUR00562"] = { -- Animal
			["Description"] = "Este personaje huele a animales.",
			["Icone"] = "Ability_Hunter_CatlikeReflexes",
			["Nom"] = "Olor a bestia",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 4,
		},
		
		-- Maladie 00601 à 00700
		["AUR00601"] = { -- Rhume
			["Description"] = "Este personaje obviamente tiene un resfriado: secreción nasal, tos y un poco de fiebre.",
			["Icone"] = "INV_Elemental_Mote_Water01",
			["Nom"] = "Resfriado",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 8,
			["Type"] = 1,
		},
		["AUR00602"] = { -- Asthme
			["Description"] = "Este personaje se queda muy rápidamente sin aliento. También sufre ataques de asma ocasionales.",
			["Icone"] = "inv_misc_volatileair",
			["Nom"] = "Asma",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 8,
			["Type"] = 1,
		},
		
		
		-- Malédictions 00701 à 00800
		["AUR00701"] = { -- Malédiction de douleur
			["Description"] = "Las ilusiones devoran el cuerpo de este personaje, pero el dolor es real...",
			["Icone"] = "Ability_Vanish",
			["Nom"] = "Maldición de dolor",
			["Createur"] = "Knilthas",
			["EtatCat"] = 9,
			["Type"] = 1,
		},
		["AUR00702"] = { -- Malédiction de désespoir
			["Description"] = "Voces interiores atormentan continuamente a este personaje.",
			["Icone"] = "Spell_Holy_PrayerofShadowProtection",
			["Nom"] = "Maldición de desesperación",
			["Createur"] = "Knilthas",
			["EtatCat"] = 9,
			["Type"] = 1,
		},
		["AUR00703"] = { -- Malédiction de l'ombre
			["Description"] = "Los hechizos de curación dañan a este personaje en vez de curarlo.",
			["Icone"] = "Ability_Rogue_EnvelopingShadows",
			["Nom"] = "Maldición de oscuridad",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 9,
			["Type"] = 1,
		},
		
		-- Magie 00801 à 00900
		["AUR00801"] = { -- Silence
			["Description"] = "Un hechizo impide a este personaje lanzar conjuros.",
			["Icone"] = "SPELL_HOLY_SILENCE",
			["Nom"] = "Silenciado",
			["Createur"] = "Knilthas",
			["EtatCat"] = 10,
			["Type"] = 1,
		},
		["AUR00802"] = { -- Miniature
			["Description"] = "¡Un hechizo ha hecho empequeñecer a este personaje!",
			["Icone"] = "INV_Gizmo_Poltryiser_01",
			["Nom"] = "Miniaturizado",
			["Createur"] = "Knilthas",
			["EtatCat"] = 10,
			["Type"] = 1,
		},
		["AUR00803"] = { -- Lenteur
			["Description"] = "Cadenas mágicas restringen los miembros de este personaje y dificultan sus movimientos.",
			["Icone"] = "Spell_Nature_TimeStop",
			["Nom"] = "Entorpecido",
			["Createur"] = "Knilthas",
			["EtatCat"] = 10,
			["Type"] = 1,
		},
		
		-- Apparence : 00901 à 01000
		["AUR00503"] = { -- Fatigue
			["Description"] = "Este personaje está cansado y no ha dormido desde hace tiempo.",
			["Icone"] = "Spell_Nature_Sleep",
			["Nom"] = "Cansado",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 11,
		},
		["AUR00901"] = { -- Sourire éclatant
			["Description"] = "Este personaje tiene una perfecta higiene dental. ¡Una sonrisa deslumbrante!",
			["Icone"] = "Achievement_Halloween_Smiley_01",
			["Nom"] = "Sonrisa deslumbrante",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 11,
			["Type"] = 3,
		},
		["AUR00902"] = { -- Silhouette musclée
			["Description"] = "¡Este personaje ha estado trabajando sus músculos, y eso se nota!",
			["Icone"] = "Spell_Nature_Strength",
			["Nom"] = "Musculoso",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 11,
			["Type"] = 3,
		},
		["AUR00903"] = { -- Soin de l'apparence
			["Description"] = "Este personaje está perfectamente arreglado y presta mucha atención a su apariencia externa.",
			["Icone"] = "Achievement_BG_most_damage_killingblow_dieleast",
			["Nom"] = "Cuidadosamente arreglado",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 11,
			["Type"] = 3,
		},
		["AUR00904"] = { -- Peinture de guerre
			["Description"] = "Este personaje lleva pinturas de guerra en su cara.",
			["Icone"] = "ability_rogue_preparation",
			["Nom"] = "Pinturas de guerra",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 11,
			["Type"] = 2,
		},
		["AUR00905"] = { -- Trempé
			["Description"] = "Este personaje está empapado.",
			["Icone"] = "inv_misc_volatilewater",
			["Nom"] = "Empapado",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 11,
			["Type"] = 2,
		},
		["AUR00906"] = { -- Richesse
			["Createur"] = "Telkostrasz",
			["Description"] = "Ropa cara, una bolsa llena de monedas... Este personaje no tiene que preocuparse por el dinero. ¡Todo lo contrario!",
			["Icone"] = "ACHIEVEMENT_GUILDPERK_CASHFLOW_RANK2",
			["Nom"] = "Adinerado",
			["EtatCat"] = 11,
		},
		["AUR00907"] = { -- Pauvreté
			["Createur"] = "Telkostrasz",
			["Description"] = "Ropa sucia con agujeros, un estómago que gruñe... Todo indica que este personaje no tiene un cobre.",
			["Icone"] = "INV_Misc_Pelt_Bear_Ruin_05",
			["Nom"] = "Necesitado",
			["EtatCat"] = 11,
		},
		["AUR00908"] = { -- Pupille dilatée
			["Description"] = "Este personaje tiene las pupilas dilatadas.",
			["Icone"] = "Ability_Hunter_BeastWithin",
			["Nom"] = "Pupilas dilatadas",
			["Createur"] = "Damön",
			["EtatCat"] = 11,
			["Type"] = 1,
		},
		-- Aura 01001 à 01100
		["AUR01001"] = { -- Confiance
			["Description"] = "Este personaje emana un aura que inspira confianza.",
			["Icone"] = "Spell_Holy_AuraMastery",
			["Nom"] = "Digno de confianza",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 14,
			["Type"] = 2,
		},
		["AUR01002"] = { -- Louche
			["Description"] = "Este personaje parece sospechoso e inspira poca confianza.",
			["Icone"] = "Ability_Rogue_WrongfullyAccused",
			["Nom"] = "Sospechoso",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 14,
			["Type"] = 2,
		},
		
		-- Symptômes 01101 à 01200
		["AUR01101"] = { -- Paralysie
			["Description"] = "Este personaje está paralizado.",
			["Icone"] = "Ability_Rogue_DeadenedNerves",
			["Nom"] = "Paralisis",
			["Createur"] = "Knilthas",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01102"] = { -- Engourdissement
			["Description"] = "Los miembros de este personaje están entumecidos. Tiene dificultades para moverse y el sentido del tacto se ve afectado.",
			["Icone"] = "Spell_Frost_ManaRecharge",
			["Nom"] = "Entumecimiento",
			["Createur"] = "Knilthas",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01103"] = { -- Affaiblissement
			["Description"] = "Este personaje está débil. Su vivacidad se reduce, al igual que sus reflejos.",
			["Icone"] = "Spell_Shadow_ManaFeed",
			["Nom"] = "Debilitamiento",
			["Createur"] = "Knilthas",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01104"] = { -- Somnolence
			["Description"] = "Este personaje tiene sueño. Está teniendo dificultades para mantenerse despierto y concentrado.",
			["Icone"] = "Spell_Nature_Polymorph",
			["Nom"] = "Adormecimiento",
			["Createur"] = "Knilthas",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01105"] = { -- Surdité
			["Description"] = "Este personaje ha perdido parcial o totalmente la audición.",
			["Icone"] = "INV_Misc_Ear_Human_02",
			["Nom"] = "Sordera",
			["Createur"] = "Knilthas",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01106"] = { -- Cécité
			["Description"] = "Este personaje ha perdido parcial o totalmente la vista.",
			["Icone"] = "Spell_Arcane_Blink",
			["Nom"] = "Ceguera",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01107"] = { -- Aphasie
			["Description"] = "Este personaje ha perdido la capacidad de hablar.",
			["Icone"] = "Ability_Priest_Silence",
			["Nom"] = "Mudez",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01108"] = { -- Nausée
			["Description"] = "Este personaje es propenso a vomitar.",
			["Icone"] = "Spell_Shadow_SoulLeech",
			["Nom"] = "Náuseas",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01109"] = { -- Fièvre
			["Description"] = "Este personaje tiene fiebre.",
			["Icone"] = "Spell_Shadow_MindRot",
			["Nom"] = "Fiebre",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01110"] = { -- Toux faible
			["Description"] = "Este personaje tose de vez en cuando.",
			["Icone"] = "Ability_Rogue_MasterOfSubtlety",
			["Nom"] = "Tos",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01111"] = { -- Amnésie partielle
			["Description"] = "Este personaje ha perdido parte de sus recuerdos.",
			["Icone"] = "Ability_Druid_Dreamstate",
			["Nom"] = "Amnesia parcial",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01112"] = { -- Amnésie totale
			["Description"] = "Este personaje ha perdido totalmente la memoria. Ni siquiera sabe quién es.",
			["Icone"] = "Ability_Druid_Dreamstate",
			["Nom"] = "Amnesia total",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		
		-----------------------
		-- Quetes : 00101 à 00500
		-----------------------
		-- Quête : Traitresse ! Horde --
		["AUR00101"] = { -- Distraction de Gryshka
			["Description"] = "Este personaje ha distraido a Gryshka. ¡Aprovecha la oportunidad para recuperar el objeto!",
			["OnLifeTimeCondi"] = "queststep(QUE00003)$==$\"006\";",
			["Nom"] = "Distracción: Gryshka",
			["EtatCat"] = 3,
			["bAjout"] = false,
			["OnLifeTimeEffet"] = "quest$QUE00003$005$1;",
			["Createur"] = "Telkostrasz",
			["Icone"] = "Achievement_Character_Orc_Female",
			["OnReceiveEffet"] = "texte$¡Gryshka está distraida!\n¡Aprovecha!$3;",
		},
		-- Quête : Traitresse ! Alliance --
		["AUR00102"] = { -- Distraction de Erika
			["Description"] = "Este personaje ha distraído a Erika. ¡Aprovecha la oportunidad para recuperar el objeto!",
			["OnLifeTimeCondi"] = "queststep(QUE00002)$==$\"006\";",
			["Nom"] = "Distracción: Erika",
			["bAjout"] = false,
			["EtatCat"] = 3,
			["OnLifeTimeEffet"] = "quest$QUE00002$005$1;",
			["Createur"] = "Telkostrasz",
			["Icone"] = "Achievement_Character_Human_Female",
			["OnReceiveEffet"] = "texte$¡Erika está distraida!\n¡Aprovecha!$3;",
		},
	};
end
--German
function TRP2_LoadDBAuras_4()
	TRP2_DB_Auras = {
		["AUR00001"] = { -- Test 1
			["Description"] = "Ein leerer Zustand, ohne Eigenschaften",
			["Nom"] = "Zustand",
			["bAjout"] = false,
		},
		-----------------------
		-- BORDEL : 00010 à 00100
		-----------------------
		["AUR00012"] = { -- Plaie à l'oeil gauche
			["Type"] = 1,
			["Description"] = "Ein kleiner Schnitt in der Nähe vom linken Auge.\nKaum sichtbar.",
			["Icone"] = "Ability_Rogue_BloodyEye",
			["EtatCat"] = 7,
			["Nom"] = "Verwundetes linkes Auge",
			["Createur"] = "Telkostrasz",
		},
		["AUR00013"] = { -- Plaie à l'oeil droit
			["Type"] = 1,
			["Description"] = "Ein kleiner Schnitt in der Nähe vom rechten Auge.\nKaum sichtbar.",
			["Icone"] = "Ability_Rogue_BloodyEye",
			["EtatCat"] = 7,
			["Nom"] = "Verwundetes rechtes Auge",
			["Createur"] = "Telkostrasz",
		},
		["AUR00014"] = { -- Fumée du sèche-cheveux
			["EtatCat"] = 12,
			["Type"] = 1,
			["Description"] = "Dieser Charakter ist mit einer dicken Schickt von Staub und Asche übersät.",
			["Date"] = "25/05/11, 00:26:07 par Telkostrasz",
			["Nom"] = "Staub und Asche",
			["Createur"] = "Telkostrasz",
			["OnUpdateCondi"] = "isswimming$==$\"1\";",
			["Icone"] = "inv_misc_dust",
			["DureeDefaut"] = 20,
			["OnUpdateEffet"] = "aura$AUR00014$0$2$1;texte${me} ist nach dem Schwimmen im Wasser wieder sauber.$1;son$Sound\\\\Spells\\\\WaterElementalLow_Imapct_Base2.wav$1$0;",
		},
		-----------------------
		-- Humeur et emotions et comportements : 00501 à 00550
		-----------------------
		-- Comportement
		["AUR00501"] = { -- Apathique
			["Createur"] = "Telkosträsz",
			["Description"] = "Dieser Charakter wirkt verschlossen und teilnahmslos",
			["Icone"] = "Spell_Shadow_MindSteal",
			["Nom"] = "Apathisch",
			["EtatCat"] = 5,
		},
		["AUR00511"] = { -- Calme
			["Createur"] = "Telkosträsz",
			["Description"] = "Dieser Charakter ist schweigsam.",
			["Icone"] = "Ability_Mage_PotentSpirit",
			["Nom"] = "Still",
			["EtatCat"] = 5,
		},
		["AUR00512"] = { -- Agité
			["Createur"] = "Telkosträsz",
			["Description"] = "Dieser Charakter ist durcheinander und aufgeregt.",
			["Icone"] = "Achievement_BG_captureflag_EOS",
			["Nom"] = "Aufgeregt",
			["EtatCat"] = 5,
		},
		["AUR00509"] = { -- Dans la lune
			["Createur"] = "Ænys",
			["Description"] = "Dieser Charakter ist abwesend, tag-träumerisch.",
			["Icone"] = "Ability_Druid_Eclipse",
			["Nom"] = "Däumchendrehen",
			["EtatCat"] = 5,
		},
		["AUR00504"] = { -- Aux aguets
			["Description"] = "Dieser Charakter achtet sehr genau darauf, was in seiner Umgebung passiert... Vielleicht muss er schnell auf etwas reagieren, wenn etwas passiert.",
			["Icone"] = "Ability_Druid_SupriseAttack",
			["Nom"] = "Wachsam",
			["Createur"] = "Elindorië",
			["EtatCat"] = 5,
		},
		["AUR00513"] = { -- Observateur
			["Createur"] = "Kâsu",
			["Description"] = "Dieser Charakter beobachtet die Leute um sich herum sehr genau und scheint mentale Notizen zu machen.",
			["Icone"] = "ACHIEVEMENT_GUILDPERK_EVERYONES A HERO_RANK2",
			["Nom"] = "Beobachter",
			["EtatCat"] = 5,
		},
		["AUR00514"] = { -- Timbré
			["Createur"] = "Anundæl",
			["Description"] = "Dieser Charakter wirkt irgendwie verrückt. Vielleicht ist es krankheitsbedingt oder er ist einfach schlecht drauf. In beiden Fällen ist es wohl sicher, ihn in Ruhe zu lassen.",
			["Icone"] = "INV_Misc_Ticket_Tarot_Madness",
			["Nom"] = "Irre",
			["EtatCat"] = 5,
		},
		["AUR00516"] = { -- Farceur
			["Createur"] = "Fimble",
			["Description"] = "Immer für einen Lacher zu haben und macht Witze aus allem, was die Leute sagen.",
			["Icone"] = "Achievement_Character_Gnome_Male",
			["Nom"] = "Joker",
			["EtatCat"] = 5,
		},
		["AUR00518"] = { -- Ivre
			["Createur"] = "Telkostrasz",
			["Description"] = "Dieser Charakter ist geradezu lächerlich betrunken!",
			["Icone"] = "INV_Drink_29_SunkissedWine",
			["Nom"] = "Sturzbetrunken",
			["EtatCat"] = 5,
			["Type"] = 1,
		},
		-- Humeur
		["AUR00517"] = { -- Amoureux
			["Createur"] = "Märion",
			["Description"] = "Dieser Charakter ist verliebt und zeigt das auch!",
			["Icone"] = "Achievement_WorldEvent_Valentine",
			["Nom"] = "Schmetterlinge",
			["EtatCat"] = 6,
		},
		["AUR00502"] = { -- Content
			["Createur"] = "Telkosträsz",
			["Description"] = "Dieser Charakter ist einfach gut gelaunt.",
			["Icone"] = "Spell_Shaman_GiftEarthmother",
			["Nom"] = "Gut drauf",
			["EtatCat"] = 6,
		},
		["AUR00505"] = { -- Colère
			["Createur"] = "Telkosträsz",
			["Description"] = "Dieser Charakter ist verärgert.",
			["Icone"] = "Spell_Misc_EmotionAngry",
			["Nom"] = "Verärgert",
			["EtatCat"] = 6,
		},
		["AUR00506"] = { -- Triste
			["Createur"] = "Telkosträsz",
			["Description"] = "Dieser Charakter macht einen traurigen Eindruck",
			["Icone"] = "Spell_Misc_EmotionSad",
			["Nom"] = "Traurig",
			["EtatCat"] = 6,
		},
		["AUR00508"] = { -- Impassible
			["Createur"] = "Telkosträsz",
			["Description"] = "Egal was diesem Charakter gerade durch den Kopf geht, man sieht es ihm nicht an.",
			["Icone"] = "Ability_Rogue_Disguise",
			["Nom"] = "Pokerface",
			["EtatCat"] = 6,
		},
		["AUR00510"] = { -- Affectueux
			["Createur"] = "Telkosträsz",
			["Description"] = "Dieser Charakter geht herzlich mit allen anderen um.",
			["Icone"] = "INV_ValentinesCandy",
			["Nom"] = "Herzlich",
			["EtatCat"] = 6,
		},
		
		-- ACTION
		["AUR00515"] = { -- Fume le cigare
			["Createur"] = "Darnat",
			["Description"] = "Wer behauptet, das sei ungesund?",
			["Icone"] = "INV_Misc_Flute_01",
			["Nom"] = "Blauer Dunst",
			["EtatCat"] = 13,
		},
		
		-- Odeur : 00551 à 00600
		["AUR00551"] = { -- Sang
			["Createur"] = "Telkostrasz",
			["Description"] = "Dieser Charakter riecht nicht getrocknetem Blut",
			["Icone"] = "Spell_Shadow_BloodBoil",
			["Nom"] = "Blutgeruch",
			["EtatCat"] = 4,
		},
		["AUR00552"] = { -- Tabac
			["Createur"] = "Telkostrasz",
			["Description"] = "Dieser Charakter duftet nach Tabak.",
			["Icone"] = "INV_Misc_Dust_02",
			["Nom"] = "Tabakduft",
			["EtatCat"] = 4,
		},
		["AUR00553"] = { -- Fromage
			["Createur"] = "Telkostrasz",
			["Description"] = "Dieser Charakter mieft nach altem Käse!",
			["Icone"] = "INV_Misc_Food_03",
			["Nom"] = "Käsemief",
			["EtatCat"] = 4,
		},
		["AUR00554"] = { -- Rose
			["Description"] = "Dieser Charakter durftet nach Rosen.",
			["Icone"] = "INV_RoseBouquet01",
			["Nom"] = "Rosenduft",
			["Createur"] = "Ulra",
			["EtatCat"] = 4,
		},
		["AUR00555"] = { -- Printemps
			["Createur"] = "Bérénisse",
			["Description"] = "Dieser Charakter duftet nach Frühling.",
			["Icone"] = "INV_Misc_TrailofFlowers",
			["Nom"] = "Frühlingsduft",
			["EtatCat"] = 4,
		},
		["AUR00556"] = { -- Foret
			["Description"] = "Dieser Charakter duftet nach Kräutern und frischem Holz",
			["Icone"] = "Ability_Druid_Flourish",
			["Nom"] = "Waldduft",
			["Createur"] = "Nandieb",
			["EtatCat"] = 4,
		},
		["AUR00557"] = { -- Cadavre
			["Description"] = "Dieser Charakter stinkt wie ein verrottender Kadaver.",
			["Icone"] = "Spell_Shadow_DeathCoil",
			["Nom"] = "Verwesungsgestank",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 4,
		},
		["AUR00558"] = { -- Œuf pourri
			["Description"] = "Dieser Charakter mieft nach verrotteten Eiern.",
			["Icone"] = "Achievement_Halloween_RottenEgg_01",
			["Nom"] = "Tausendjährige Eier",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 4,
		},
		["AUR00559"] = { -- Viande fraiche
			["Description"] = "Dieser Charakter riecht nach leckerem frischen Fleisch.",
			["Icone"] = "INV_Misc_Food_Meat_Raw_03",
			["Nom"] = "Fleischgeruch",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 4,
		},
		["AUR00560"] = { -- Poisson
			["Description"] = "Dieser Charakter duftet nach FRISCHEM Fisch!",
			["Icone"] = "INV_Misc_Fish_17",
			["Nom"] = "Frischfischgeruch",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 4,
		},
		["AUR00561"] = { -- Mer
			["Description"] = "Dieser Charakter riecht nach Salzwasser und Schellfisch",
			["Icone"] = "INV_Misc_Fish_15",
			["Nom"] = "Duft des Ozeans",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 4,
		},
		["AUR00562"] = { -- Animal
			["Description"] = "Dieser Charakter riecht nach Tieren.",
			["Icone"] = "Ability_Hunter_CatlikeReflexes",
			["Nom"] = "Tiergeruch",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 4,
		},
		
		-- Maladie 00601 à 00700
		["AUR00601"] = { -- Rhume
			["Description"] = "Dieser Charakter ist eindeutig erkältet: Rote Nase und wie es aussieht auch Fieber.",
			["Icone"] = "INV_Elemental_Mote_Water01",
			["Nom"] = "Erkältung",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 8,
			["Type"] = 1,
		},
		["AUR00602"] = { -- Asthme
			["Description"] = "Dieser Charakter ist sehr leicht außer Atem.",
			["Icone"] = "inv_misc_volatileair",
			["Nom"] = "Asthma",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 8,
			["Type"] = 1,
		},
		
		
		-- Malédictions 00701 à 00800
		["AUR00701"] = { -- Malédiction de douleur
			["Description"] = "Illusionen zerfressen den Körper des Charakters...Aber der Schmerz ist echt.",
			["Icone"] = "Ability_Vanish",
			["Nom"] = "Fluch der Schmerzen",
			["Createur"] = "Knilthas",
			["EtatCat"] = 9,
			["Type"] = 1,
		},
		["AUR00702"] = { -- Malédiction de désespoir
			["Description"] = "Innere Stimmen sprechen mit diesem Charakter",
			["Icone"] = "Spell_Holy_PrayerofShadowProtection",
			["Nom"] = "Fluch der Stimmen",
			["Createur"] = "Knilthas",
			["EtatCat"] = 9,
			["Type"] = 1,
		},
		["AUR00703"] = { -- Malédiction de l'ombre
			["Description"] = "Heilzauber verletzen diesen Charakter, anstatt ihn zu heilen.",
			["Icone"] = "Ability_Rogue_EnvelopingShadows",
			["Nom"] = "Fluch der Schatten",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 9,
			["Type"] = 1,
		},
		
		-- Magie 00801 à 00900
		["AUR00801"] = { -- Silence
			["Description"] = "Ein Zauber hindert den Charakter am Sprechen.",
			["Icone"] = "SPELL_HOLY_SILENCE",
			["Nom"] = "Stillzauber",
			["Createur"] = "Knilthas",
			["EtatCat"] = 10,
			["Type"] = 1,
		},
		["AUR00802"] = { -- Miniature
			["Description"] = "Ein Zauberspruch hat diesen Charakter schrumpfen lassen!",
			["Icone"] = "INV_Gizmo_Poltryiser_01",
			["Nom"] = "MiniMe",
			["Createur"] = "Knilthas",
			["EtatCat"] = 10,
			["Type"] = 1,
		},
		["AUR00803"] = { -- Lenteur
			["Description"] = "Magische Fesseln umgreifen die Gliedmaßen des Charakters und hindern ihm am Fortkommen",
			["Icone"] = "Spell_Nature_TimeStop",
			["Nom"] = "Verlangsamt",
			["Createur"] = "Knilthas",
			["EtatCat"] = 10,
			["Type"] = 1,
		},
		
		-- Apparence : 00901 à 01000
		["AUR00503"] = { -- Fatigue
			["Description"] = "Dieser Charakter wirkt müde und hat wohl schon lang nicht mehr geschlafen.",
			["Icone"] = "Spell_Nature_Sleep",
			["Nom"] = "Übermüdet",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 11,
		},
		["AUR00901"] = { -- Sourire éclatant
			["Description"] = "Dieser Charakter hat einfach perfekte Zähne. Was für ein umwerfendes Lächeln!",
			["Icone"] = "Achievement_Halloween_Smiley_01",
			["Nom"] = "Strahlendes Lächeln",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 11,
			["Type"] = 3,
		},
		["AUR00902"] = { -- Silhouette musclée
			["Description"] = "Dieser Charakter hat trainiert und zeigt das auch!",
			["Icone"] = "Spell_Nature_Strength",
			["Nom"] = "Bodybuider",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 11,
			["Type"] = 3,
		},
		["AUR00903"] = { -- Soin de l'apparence
			["Description"] = "Dieser Charakter wirkt sehr gepflegt und scheint hohen Wert auf sein Äußeres zu legen.",
			["Icone"] = "Achievement_BG_most_damage_killingblow_dieleast",
			["Nom"] = "Perfekter Auftritt",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 11,
			["Type"] = 3,
		},
		["AUR00904"] = { -- Peinture de guerre
			["Description"] = "Dieser Charakter trägt Kriegsbemalung im Gesicht.",
			["Icone"] = "ability_rogue_preparation",
			["Nom"] = "Kriegsbemalung",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 11,
			["Type"] = 2,
		},
		["AUR00905"] = { -- Trempé
			["Description"] = "Dieser Charakter ist bis auf die Knochen durchnässt.",
			["Icone"] = "inv_misc_volatilewater",
			["Nom"] = "Durchnässt",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 11,
			["Type"] = 2,
		},
		["AUR00906"] = { -- Richesse
			["Createur"] = "Telkostrasz",
			["Description"] = "Teure Klamotten, prall gefüllter Geldbeutel... Dieser Charakter muss sich über Geld keine Sorgen machen. Beweis ihm das Gegenteil!",
			["Icone"] = "ACHIEVEMENT_GUILDPERK_CASHFLOW_RANK2",
			["Nom"] = "Zu Reich",
			["EtatCat"] = 11,
		},
		["AUR00907"] = { -- Pauvreté
			["Createur"] = "Telkostrasz",
			["Description"] = "Abgetragene Klamotten mit Löchern drin. Dieser Charakter hat wohl keine Kupfermünze.",
			["Icone"] = "INV_Misc_Pelt_Bear_Ruin_05",
			["Nom"] = "Verarmt",
			["EtatCat"] = 11,
		},
		["AUR00908"] = { -- Pupille dilatée
			["Description"] = "Die Pupillen des Charakters sind geweitet.",
			["Icone"] = "Ability_Hunter_BeastWithin",
			["Nom"] = "Pinker Elefant",
			["Createur"] = "Dämon",
			["EtatCat"] = 11,
			["Type"] = 1,
		},
		-- Aura 01001 à 01100
		["AUR01001"] = { -- Confiance
			["Description"] = "Dieser Charakter wirkt vertrauenswürdig.",
			["Icone"] = "Spell_Holy_AuraMastery",
			["Nom"] = "Vertrauenerweckend",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 14,
			["Type"] = 2,
		},
		["AUR01002"] = { -- Louche
			["Description"] = "Dieser Charakter wirkt zwielichtig und flöst nicht gerade Vertrauen ein.",
			["Icone"] = "Ability_Rogue_WrongfullyAccused",
			["Nom"] = "Zwielichtig",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 14,
			["Type"] = 2,
		},
		
		-- Symptômes 01101 à 01200
		["AUR01101"] = { -- Paralysie
			["Description"] = "Dieser Charakter ist paralysiert.",
			["Icone"] = "Ability_Rogue_DeadenedNerves",
			["Nom"] = "Paralysiert",
			["Createur"] = "Knilthas",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01102"] = { -- Engourdissement
			["Description"] = "Die Gliedmaßen dieses Charakters sind taub. Das erschwert das Vorrankommen.",
			["Icone"] = "Spell_Frost_ManaRecharge",
			["Nom"] = "Taubes Gefühl",
			["Createur"] = "Knilthas",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01103"] = { -- Affaiblissement
			["Description"] = "Dieser Charakter ist stark geschwächt. Seine Reflexe und seine Kraft leiden darunter.",
			["Icone"] = "Spell_Shadow_ManaFeed",
			["Nom"] = "Geschwächt",
			["Createur"] = "Knilthas",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01104"] = { -- Somnolence
			["Description"] = "Dieser Charakter ist sehr schläfrig. Es fällt ihm schwer sich wachzuahalten, geschweige den zuzuhören.",
			["Icone"] = "Spell_Nature_Polymorph",
			["Nom"] = "Schläfrig",
			["Createur"] = "Knilthas",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01105"] = { -- Surdité
			["Description"] = "Dieser Charakter kann nichts hören.",
			["Icone"] = "INV_Misc_Ear_Human_02",
			["Nom"] = "Taub",
			["Createur"] = "Knilthas",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01106"] = { -- Cécité
			["Description"] = "Dieser Charakter ist blind.",
			["Icone"] = "Spell_Arcane_Blink",
			["Nom"] = "Blind",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01107"] = { -- Aphasie
			["Description"] = "Der Charakter ist Stumm.",
			["Icone"] = "Ability_Priest_Silence",
			["Nom"] = "Stumm",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01108"] = { -- Nausée
			["Description"] = "Dieser Charakter vermittelt den Eindruck, als müsse er sich gleich übergeben.",
			["Icone"] = "Spell_Shadow_SoulLeech",
			["Nom"] = "Übelkeit",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01109"] = { -- Fièvre
			["Description"] = "Dieser Charakter scheint Fieber zu haben.",
			["Icone"] = "Spell_Shadow_MindRot",
			["Nom"] = "Fieber",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01110"] = { -- Toux faible
			["Description"] = "Dieser Charakter hustet ab und an.",
			["Icone"] = "Ability_Rogue_MasterOfSubtlety",
			["Nom"] = "Husten",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01111"] = { -- Amnésie partielle
			["Description"] = "Dieser Charakter hat Teile seines Gedächnisses verloren",
			["Icone"] = "Ability_Druid_Dreamstate",
			["Nom"] = "Teilamnesie",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		["AUR01112"] = { -- Amnésie totale
			["Description"] = "Dieser Charakter hat wirklich alle seine Erinnerungen verloren.",
			["Icone"] = "Ability_Druid_Dreamstate",
			["Nom"] = "Amnesie",
			["Createur"] = "Telkostrasz",
			["EtatCat"] = 16,
			["Type"] = 1,
		},
		
		-----------------------
		-- Quetes : 00101 à 00500
		-----------------------
		-- Quête : Traitresse ! Horde --
		["AUR00101"] = { -- Distraction de Gryshka
			["Description"] = "Dieser Charakter lenkt Gryshkas Aufmerksamkeit auf sich. Er kann diese Ablenkung dazu nutzen um ein Gegenstand von ihr zu stehlen!",
			["OnLifeTimeCondi"] = "queststep(QUE00003)$==$\"006\";",
			["Nom"] = "Ablenkung: Gryshka",
			["EtatCat"] = 3,
			["bAjout"] = false,
			["OnLifeTimeEffet"] = "quest$QUE00003$005$1;",
			["Createur"] = "Telkostrasz",
			["Icone"] = "Achievement_Character_Orc_Female",
			["OnReceiveEffet"] = "texte$Gryshka wird abgelenkt!\nNutze die Gelegenheit und durchsuche sie!$3;",
		},
		-- Quête : Traitresse ! Alliance --
		["AUR00102"] = { -- Distraction de Erika
			["Description"] = "Dieser Charakter lenkt Erika Aufmerksamkeit auf sich. Er kann diese Ablenkung dazu nutzen um ein Gegenstand von ihr zu stehlen!",
			["OnLifeTimeCondi"] = "queststep(QUE00002)$==$\"006\";",
			["Nom"] = "Ablenkung: Erika",
			["bAjout"] = false,
			["EtatCat"] = 3,
			["OnLifeTimeEffet"] = "quest$QUE00002$005$1;",
			["Createur"] = "Telkostrasz",
			["Icone"] = "Achievement_Character_Human_Female",
			["OnReceiveEffet"] = "texte$Erika wird abgelenkt!\nNutze die Gelegenheit und durchsuche sie!$3;",
		},
	}
end